##******************************#
#*******************************#
#***|                       |***#
#***|  FORAY IN THE FOREST  |***#
#***|    Mr.M  &  Nisaba    |***#
#***|                       |***#
#*******************************#
#******************************##

%ext ck4

##****************************#
#***|  Temporary Patches  |***#
#****************************##

# Keen starts game in Level 3
%patch $5CBB $7A68W $0003W

# Don't end game if Keen reads
%patch $BC68 $EB


#**************************#
#***|  Patching Stuff  |***#
#**************************#

# Graphics files
%egahead EGAHEAD.CK4

# Map/Level files
%maphead MAPHEAD.CK4

# Tileinfo file
%patchfile $249C2 KEEN4.TLI

# Loading screen
%patchfile $1FE47 CK4LOAD.BIN

# Sound/Music patch files
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary

# Don't need debug mode to use F10 cheats
%patch $7AB7 $90 $90

# Levels F10 + W access
%patch $77E4 $13  

# Story text file
%patchfile $1EE40 "Forest.CK4"


#**********************#
#***|  Warp Cheat  |***#
#**********************#

# Warp Text
%patch $2F418 " Warp to which level (1-3):" $00

# Levels F10 + W accesses
%patch $77E4 $03


#**************************#
#***|  Colour Palettes  |***#
#**************************#

# Star Wars Background palette:
%patch $2F05E $00 $01 $02 $03 $12 $10 $06 $07 #Dark colors
              $1F $1F $1F $1F $1F $1F $1F $1F #Light colors

# Terminator text palette:
%patch $2F078 $00 $02 $02 $12 $01 $01 $01 $01 #Dark colors
              $11 $11 $11 $11 $13 $13 $13 $13 #Light colors

# Terminator text palette 2, screen moves out:
%patch $2F088 $00 $00 $02 $02 $12 $01 $01 $01 #Dark colors
              $01 $11 $11 $11 $11 $13 $13 $13 #Light colors


#***********************#
#***|  Help Screen  |***#
#***********************#

# Disable Help-Section
%patch $3F09  $EB     # Unknown, initiation screen?
%patch $51AB  $EB     # During terminator text
%patch $7930  $EB     # In game levels
%patch $1CED9 $90 $90 # In Main Menu

# Computerwrist screen color: Visible by default)
%patch $98F5 $0002W #Color dark green used for screen background
%patch $99F8 $0002W #Color used behind help pointer

# Help\Ending pages background color (Visible by default)
%patch $95FB $0002W #Color dark green used for screen background

# Help section documents
%patch $2F586 $1286W #About
              $1289W #Community Mods
              $1284W #The story
              $1285W #The game
              $1283W #Computer Wrist
			  
# Help menu option height
%patch $99DE $0018W #Height of hand options 1
%patch $99FC $0018W #Height of hand options 2
%patch $9A07 $0018W #Height of hand options 3	

%patch $99D7 $002DW #Hand (At 48,48)
%patch $99E3 $0030W #v location 1
%patch $99E7 $0025W #h location 1
%patch $9A0C $0030W #v location 2
%patch $9A10 $0025W #h location 2

#Rescued text
%patch $7E20 $0055W #Vertical
%patch $7E26 $0050W #Horizontal
%patch $7E2C $0040W #Maximum text width
%patch $7E2F $062CW #Text read from
%patch $2F49C "RESCUED" $00

%patch $2F49C "TROPHY" $00

#*****************************#
#***|  In-Game Demo Text  |***#
#*****************************#

# Keen Dreams style level loading box -Keen 4
%patch $38FF $EB $22

#%patch $19F34  $46DDW #Text called from
#%patch $3354D "  Loading...   " $00

# What to display with nonexistent levels
%patch $9CB8 $1288W #Text
%patch $9CC4 $9FFDW #Memory variable 1
%patch $9D7D $9FFDW #Memory variable 2
%patch $9CDA $90 $90 $90 $90 $90

# Level state for entering nonexistent levels - Display image, reload map
%patch $6BCD $0EB2W #Got Foot state ($08)
%patch $6AF2 $0E $E8 $F150W  $9A $16540139RL     $9A $1D060999RL     $9A $09150B2DRL
             $C7 $06 $7A68W $0000W  $C7 $06 $7A70W $0002W  $EB $0B

# Trigger message for levels above 3
%patch $DF7C $83 $3E $7A68W  $03 $76 $05 $83 $06 $7A70W  $05

# Don't stop music during message
%patch $9153 $90 $90 $90 $90
%patch $9CDA $90 $90 $90 $90 $90


#*****************#
#***|  Demos  |***#
#*****************#

# Remove Story screen from demo loop
%patch $3CBD $04D1W

# Demo list length
%patch $3C0B $02

# Demo list location
%patch $3C16 $04E9W #$3CB9

# Main menu actions list
%patch $3CB9 $0448W #3C18: Terminator sequence & title screen
%patch $3CBB $046CW #3C3C: Star wars story
%patch $3CBD $0481W #3C51: High Score demo (Demo4)
%patch $3CBF $0473W #3C43: Demo 1 ()
%patch $3CC1 $045FW #3C2F: Demo 0 ()
%patch $3CC3 $0488W #3C58: Demo 2 ()
%patch $3CC5 $0496W #3C66: Demo 3 ()


#*********************#
#***|  Creatures  |***#
#*********************#

#***|    Lick     |***#
#*********************#

# Lick is deadly all the time, new collision
%patch $11423 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $09 #Check for Keen (Type 2)
              $9A $0B8013E9RL     $5F $5E $5D $CB $83 $3D $03 $75 $12
              $B8 $312EW  $50 $57 $56 $9A $09DC1695RL     $83 $C4 $06 $83 $6C
              $18 $10 $5F $5E $5D $CB

# Bouncing Lick uses this too
%patch $31E4A $10800C23RL #Lick bouncing
%patch $31E68 $10800C23RL #Lick bouncing
%patch $31E86 $10800C23RL #Lick bouncing
%patch $31EA4 $10800C23RL #Lick bouncing

# Flame Keen if he is this many tiles or closer vertically
#%patch $1137D $FF00W #1 tile above
#%patch $11384 $0100W #1 tile below

# Flame Keen, max & min distance
%patch $11395 $0400W #1.5 tiles right
%patch $113A6 $FD00W #2 tiles left

# Distance check between short & long hops
%patch $113C9 $0480W
# If the Lick is closer than this to Keen, it will perform a smaller hop, to try & achieve the ideal firebreathing distance. 
# Setting this higher will cause the Lick to take smaller hops sooner.

# Height for short hops (Nisaba edit: lick flies under the ceiling, fun!)
#%patch $113DA $20 $FF  # default is -32
# Making this number smaller will make the Lick's leap less high, and shorter as a result.

# Don't play sound when Lick flames
%patch $113AA $EB $0A


#***|  Inchworm   |***#
#*********************#

# Inchworm behavior code
#%patch $10F70 $55 $8B $EC $56 $8B $76 $06 $8B $44 $0A $8B $1E $A7D6W  $3B $47
#              $0D $76 $08 $C7 $44 $0E $FFFFW  $5E $5D $CB $C7 $44 $0E $0001W  
#              $5E $5D $CB


#*****************#
#***|  Music  |***#
#*****************#

#This is the music played in each level:
#             VALUE   LEVEL                 MUSIC PLAYED         LEVEL No
%patch $2F206 $0000W  #Map                  (Shadowlands RMX)      0
              $0001W  #The Outpost          (NiteLite Mr.M)        1
              $0003W  #Placeholder          (Education Mr. M)      2
              $0002W  #Demo BWB             (Oasis RMX)            3
              $0004W  #Cave of Descendants  (Too Hot)              4
              $0002W  #Chasm of Chills      (Too Hot)              5
              $0004W  #Crystalus            (Kick in the Pants)    6
              $0003W  #Hillville            (Slug Village)         7
              $0001W  #Sand Yego            (Eat your Veggies)     8
              $0001W  #Miragia              (Eat your Veggies)     9
              $0001W  #Lifewater Oasis      (Eat your Veggies)    10
              $0002W  #Pyramid of Moons     (Too Hot)             11
              $0002W  #Pyramid of Shadows   (Too Hot)             12
              $0002W  #Pyramid of Ancients  (Too Hot)             13
              $0002W  #Pyramid of Forbidden (Too Hot)             14
              $0002W  #Isle of Tar          (Too Hot)             15
              $0002W  #Isle of Fire         (Too Hot)             16
              $0001W  #Well of Wishes       (Eat your Veggies)    17
              $0002W  #Bwb Megarocket       (Slug Village)        18
              $FFFFW  #High scores          (No music, "Fanfare") 19


#***************#
#***|  BWB  |***#
#***************#

# BwB: Level 16 only 
%patch $60FD $03 $74

			  
#***********************#
#***|  Level Names  |***#
#***********************#

%patch $2F191 "Exit to Ancient Forest" $00

#Level entry texts
%patch $1F040 "Keen wanders the" $0A "Ancient Forest" $00
%patch $1F060 "Keen investigates" $0A "the Outpost" $00
%patch $1F07E "Keen discovers" $0A "the forgotten Pyramid" $00
%patch $1F0A8 "Keen launches into the" $0A "BWB Megarocket" $00

#Level name pointers
%patch $307C8 $1F000040RL #Keen wanders the_Ancient Forest
%patch $307CC $1F000060RL #Keen investigates_the Outpost
%patch $307D0 $1F00007ERL #Keen discovers_the forgotten Pyramid
%patch $307D4 $1F0000A8RL #Keen launches into the_BWB Megarocket

#Level names
%patch $1F34C "The Ancient Forest" $00
%patch $1F35F "The Outpost" $00
%patch $1F36B "The Forgotten Pyramid" $00

#Level name pointers
%patch $30764 $1F00034CRL #The Ancient Forest
%patch $30768 $1F00035FRL #The Outpost
%patch $3076C $1F00036BRL #The Forgotten Pyramid
%patch $30770 $1F0000BFRL #Bean-with-Bacon_Megarocket


#**********************#
#***|  High Score  |***#
#**********************#

# Don't ask for player's name for new highscore
%patch $5C11 $90 $90 $90 $90 $90

# Number of high scores
%patch $5AB7 $00
%patch $5BAA $00

# Names:
%patch $33234 "Mr. M" $00      # orig author of this mod but unfortunately lost all files via bad hardware crash
%patch $33274 "Nisaba" $00     # recreated everything from scratch
%patch $332B4 "K1ng_Duk3" $00  # extracted music tracks from K4-Demo version
%patch $332F4 "NY00123" $00    # provided helpful IRC conversations
%patch $33334 "Levellass" $00  # patched (nearly) everything like crazy
%patch $33374 "Ceilick" $00    # graphics contributions
%patch $333B4 "Xky Rauh" $00   # stole enemy creature from Xky
%patch $333F4 "Gridlock" $00   # graphics contributions

# Points: (10'000)
%patch $3326E $00000000L
%patch $332AE $00000000L
%patch $332EE $00000000L
%patch $3332E $00000000L
%patch $3336E $00000000L
%patch $333AE $00000000L
%patch $333EE $00000000L
%patch $3342E $00000000L

# Number of council members saved:
%patch $33272 $0000W
%patch $332B2 $0000W
%patch $332F2 $0000W
%patch $33332 $0000W
%patch $33372 $0000W
%patch $333B2 $0000W
%patch $333F2 $0000W
%patch $33432 $0000W

# Position of names and scores
%patch $5A16 $0083W #Vertical location of table
%patch $5A1F $0028W #Horizontal position of names column
%patch $5A9A $0118W #Horizontal position of scores column

# Name entry position
%patch $5BE4 $0083W #Vertical
%patch $5BED $0028W #Horizontal

# Members saved column
%patch $6BAC $7A5EW #What game variable is displayed
%patch $5A2E $00B8W #Horizontal position
%patch $5A38 $0047W #8x8 tile used
%patch $5A50 $08    #8x8 tile separation


%end
